<?php
    namespace Nexus\Core
    {

        use Nexus\Helpers\DataAPI;
        use Nexus\Config\cConfig;
        use Nexus\Misc\cHelpers;
        use Nexus\Misc\Helpers;

        include "./config.php";
        include "./dataapi.php";
        include "./apihelpers.php";

        //look comments :D
        //initialize globals here

        class cActiveClient
        {
            static public function IsLoggedIn()
            {
                //iffy on security look into better way
                //edit: better way is to make session tokens may actually cause issues with some applications
                // might do this with a session manager like I did for SDPBC
                if(!isset($_SESSION['userid']))
                    return false;
                return true;
            }

            static public function Login($username, $password)
            {
                if (self::IsLoggedIn())
                    return true;

               $ret = DataAPI::Instance()->Select("id,password,email,rank,firstname,lastname,registeredtime","users","email", "s",$username);

               if (strcmp($ret['email'], $username))
               {
                   cHelpers::AddLog("Failed Login: Unknown User -> " . $username, "[NEXUS]");
                   return false;
               }

               if (!strcmp($ret['password'], '0'))
               {
                   self::ChangePassword($username, $password);
                   $_SESSION = array_merge(Array(
                       'userid' => $ret['id'],
                       'rank' => $ret['rank'],
                       'name' => $ret['email'],
                       'firstname' => $ret['firstname'],
                       'lastname' => $ret['lastname'],
                       'username' => $ret['email']), $_SESSION);

                   cHelpers::AddLog("SUCCESSFUL LOGIN", $ret['email']);
                   return true;

               }

                $hashedpass = cHelpers::GenPassSalt($ret['email'],$ret['id'],$password,$ret['registeredtime']);

               if (!strcmp($hashedpass, $ret['password']))
               {

                   $_SESSION = array_merge(Array(
                        'userid' => $ret['id'],
                        'rank' => $ret['rank'],
                        'name' => $ret['email'],
                        'firstname' => $ret['firstname'],
                        'lastname' => $ret['lastname'],
                        'username' => $ret['email'],
                        'password' => $hashedpass), $_SESSION);

                    cHelpers::AddLog("SUCCESSFUL LOGIN", $ret['email']);

                    return true;
               }


                return false;
            }
            static public function Register($email, $password, $firstname, $lastname,$phone,$state )
            {

                if (!isset($email) || !isset($firstname) || !isset($lastname) || !isset($phone)|| !isset($state)){
                    cHelpers::AddLog("Add User Function Called Without All Params?", "[NEXUS]");
                    return;
                }

                DataAPI::Instance()->Insert("users","email|password|rank|firstname|lastname|phone|state", "sssssss",$email,"0", "5", $firstname, $lastname,$phone,$state);

                cHelpers::AddLog( "Added User", $email);
                self::ChangePassword($email, $password);

            }
            static public function CreateOpportunity($userid, $firstname, $lastname,$buisnessname,$email,$phone,$address1,$address2,$city,$state,$zip,$description )
            {

                if (!isset($userid) || !isset($firstname) || !isset($lastname) || !isset($buisnessname) || !isset($email)){
                    cHelpers::AddLog("Add OPR Function Called Without All Params?", "[NEXUS]");
                    return;
                }

                DataAPI::Instance()->Insert("opportunities","userid|firstname|lastname|buisnessname|email|phone|address1|address2|city|state|zipcode|description","ssssssssssss",
                    $userid,$firstname,$lastname,$buisnessname,$email,$phone,$address1,$address2,$city,$state,$zip,$description );


                cHelpers::AddLog( "Added Opportunity", $email);
                return DataAPI::Instance()->Select("id","opportunities","email|firstname|lastname|userid", "ssss", $email,$firstname,$lastname,$userid)['id'];

            }
            static public function AddOpportunityFiles($userid,$opr_id, $files )
            {

                if (!isset($userid) || !isset($opr_id) || !isset($files) ){
                    cHelpers::AddLog("Add OPR Files Function Called Without All Params?", "[NEXUS]");
                    return;
                }
                foreach ($files['files'] as $file)
                {
                    print_r($file);
                    DataAPI::Instance()->Insert("files", "userid|opr_id|data|ext|name|size", "ssssss", $userid, $opr_id,base64_encode(file_get_contents($file['tmp_name'])),$file['type'],$file['name'],$file['size']);
                }



                cHelpers::AddLog( "Added OPR Files", $userid);

            }
            static public function GetAgentOpportunities($userid)
            {

                if (!isset($userid) ){
                    cHelpers::AddLog("Get OPR Function Called Without All Params?", "[NEXUS]");
                    return;
                }



                return DataAPI::Instance()->SelectSpecial("*","opportunities","userid","s",$userid );


            }
            static public function GetAgentOpportunitiy($opr_id)
            {

                if (!isset($opr_id) ){
                    cHelpers::AddLog("Get OPR Function Called Without All Params?", "[NEXUS]");
                    return;
                }



                return DataAPI::Instance()->Select("*","opportunities","id","s",$opr_id );


            }
            static public function ChangePassword($email, $newpassword)
            {
                if (!isset($email) || !isset($newpassword))
                {
                    cHelpers::AddLog("Change Password Function Called Without Params?", "[NEXUS]");
                    return;
                }

                $ret = DataAPI::Instance()->Select("id,registeredtime","users","email", "s", $email);

                $hashedpass = cHelpers::GenPassSalt($email,$ret['id'],$newpassword,$ret['registeredtime']);

                DataAPI::Instance()->Update("users","password", "email", "ss", $hashedpass, $email);

                $_SESSION['password'] = $hashedpass;

                cHelpers::AddLog("Changed password", $email);

            }

            static public function ChangeRole($id, $role)
            {
                if (!isset($id) || !isset($role))
                {
                   cHelpers::AddLog("Change Role Function Called Without Params?", "[NEXUS]");
                    return;
                }

                DataAPI::Instance()->Update("users","rank", "id", "ss", $role, $id);

                cHelpers::AddLog("Changed Rank", $id);

            }

            static public function AddProfilePicture($userid, $avatar )
            {

                if (!isset($userid) || !isset($avatar) ){
                    cHelpers::AddLog("Add User Function Called Without All Params?", "[NEXUS]");
                    return;
                }
                $ret=  DataAPI::Instance()->Select("id","profile_pictures","userid", "s", $userid)['id'];

                if (empty($ret)) {

                    DataAPI::Instance()->Insert("profile_pictures", "userid|image", "ss", $userid, base64_encode($avatar));
                } else
                {
                    print "esest";
                    DataAPI::Instance()->Update("profile_pictures","image", "userid", "ss",  base64_encode($avatar), $userid);
                }

                cHelpers::AddLog( "Added Profile Picture", $userid);

            }
            static public function GetProfilePicture($userid)
            {

                if (!isset($userid) ){
                    cHelpers::AddLog("Add User Function Called Without All Params?", "[NEXUS]");
                    return;
                }
                $ret=  DataAPI::Instance()->Select("id","profile_pictures","userid", "s", $userid)['id'];

                if (empty($ret)) {

                   return DataAPI::Instance()->Select("image","profile_pictures","userid", "s", 0)['image'];
                } else
                {

                   return DataAPI::Instance()->Select("image","profile_pictures","userid", "s", $userid)['image'];
                }


            }
            static public function BlacklistUser($id, $reason, $invokingid)
            {
                if (!isset($id) || !isset($reason) || !isset($invokingid))
                {
                   cHelpers::AddLog("Okay, Contact Truix", "[SECURITY]");
                    return;
                }

                DataAPI::Instance()->Update("users","blacklisted|blacklistuser|blacklistreason", "id", "ssss", 1, $invokingid,$reason, $id);

                cHelpers::AddLog("BlackListed User: " . $id, $invokingid);

            }

            static public function AddUser($user, $role, $firstname, $lastname )
            {

                if (!isset($user) || !isset($firstname) || !isset($lastname) || !isset($role)){
                    Helpers::AddLog("Add User Function Called Without All Params?", "[NEXUS]");
                    return;
                }

                DataAPI::Instance()->Insert("users","user|password|rank|firstname|lastname", "sssss",$user,"0", $role, $firstname, $lastname);

                cHelpers::AddLog( "Added User", $user);

            }

            static public function DeleteUser($id)
            {
                if (!isset($id)){
                    cHelpers::AddLog("Delete User Function Called Without Params?", "[NEXUS]");
                    return;
                }

                DataAPI::Instance()->Delete("users","id","s",$id);

                cHelpers::AddLog("Deleted User", $id);

            }

            static public function ResetPassword($id)
            {
                if (!isset($id))
                {
                    cHelpers::AddLog("Reset Password Function Called Without Params?", "[NEXUS]");
                    return;
                }

                DataAPI::Instance()->Update("users","password", "id", "ss", "0", $id);

                cHelpers::AddLog("Reset Password", $id);

            }




            static public function CheckUserPermission($permission,$userid, $log_failed = true)
            {
                $permid =  DataAPI::Instance()->Select("id","permissions","permission", "s", $permission)['id'];

                if (!isset($permid))
                    return false;

                $rank = DataAPI::Instance()->Select("rank","users","id", "s", $userid)['rank'];

                if (!isset($rank))
                    return false;

                print_r($rank);
                $role_perm = DataAPI::Instance()->Select("role","role_permission_list","role|permission_id", "ss", $rank, $permid);
                if (isset($role_perm))
                    return true;

                $user_perm = DataAPI::Instance()->Select("*","user_permission_list","user|permission_id", "ss", $userid, $permid);
                if (isset($user_perm))
                    return true;

                if ($log_failed)
                \Nexus\Misc\cHelpers::AddLog("Permission Mismatch: " . $permission, $userid,4,4);
                return false;

            }

            static public function Logout()
            {
                session_destroy();
                $_SESSION = NULL;
            }
        }
        class cInventory
        {
            public static function ReadTable()
            {

            }
        }
    }
?>