<?php
    namespace Nexus\Misc
    {

        use Nexus\Helpers\DataAPI;

        class cHelpers
        {
            static public function reArrayFiles(&$files) {
                $uploads = array();
                foreach($_FILES as $key0=>$FILES) {
                    foreach($FILES as $key=>$value) {
                        foreach($value as $key2=>$value2) {
                            $uploads[$key0][$key2][$key] = $value2;
                        }
                    }
                }
                $files = $uploads;
                return $uploads; // prevent misuse issue
            }
            static public function GenPassSalt($user, $id, $pass, $time)
            {

                $hasheduser = hash("whirlpool", $user);
                $hashedid = hash("crc32", $id);
                $hashedtime = hash("md5", $time);
                $hashedpass = hash("sha256", $pass);

                return hash("sha512", $hashedid . $hasheduser . $hashedpass . $hashedtime);
            }

            static public function GenerateRandomString($n)
            {
                $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
                $randomString = '';
                for ($i = 0; $i < $n; $i++){
                    $index = rand(0, strlen($characters) - 1);
                    $randomString .= $characters[$index];
                }

                return $randomString;
            }

            static public function BuildTimeDeltaString($time, $expire_time = false)
            {
                $times = "";
                $start_date = new DateTime($time);
                $since_start = $start_date->diff(new DateTime());
                if ($expire_time){
                    if (!$since_start->invert){
                        return "expired";
                    }
                }
                if ($since_start->y > 0){
                    $times .= $since_start->y . ' Years ';
                }
                if ($since_start->m > 0){
                    $times .= $since_start->m . ' Months ';
                }
                if ($since_start->d > 0){
                    $times .= $since_start->d . ' Days ';
                }
                if ($since_start->h > 0){
                    $times .= $since_start->h . ' Hours ';
                }
                if ($since_start->i > 0){
                    $times .= $since_start->i . ' Minutes ';
                }
                if ($since_start->s > 0){
                    $times .= $since_start->s . ' Seconds';
                }

                return $times;
            }

            static public function CSVToJSON($file)
            {
                $array = array_map("str_getcsv", explode("\n", $file));
                $json = json_encode($array);

                return $json;
            }

            static public function PrettyPrint($json)
            {

                $result = '';
                $level = 0;
                $in_quotes = false;
                $in_escape = false;
                $ends_line_level = NULL;
                $json_length = strlen($json);
                for ($i = 0; $i < $json_length; $i++){
                    $char = $json[$i];
                    $new_line_level = NULL;
                    $post = "";
                    if ($ends_line_level !== NULL){
                        $new_line_level = $ends_line_level;
                        $ends_line_level = NULL;
                    }
                    if ($in_escape){
                        $in_escape = false;
                    }
                    else{
                        if ($char === '"'){
                            $in_quotes = !$in_quotes;
                        }
                        else{
                            if (!$in_quotes){
                                switch ($char){
                                    case '}':
                                    case ']':
                                        $level--;
                                        $ends_line_level = NULL;
                                        $new_line_level = $level;
                                        break;
                                    case '{':
                                    case '[':
                                        $level++;
                                    case ',':
                                        $ends_line_level = $level;
                                        break;
                                    case ':':
                                        $post = " ";
                                        break;
                                    case " ":
                                    case "\t":
                                    case "\n":
                                    case "\r":
                                        $char = "";
                                        $ends_line_level = $new_line_level;
                                        $new_line_level = NULL;
                                        break;
                                }
                            }
                            else{
                                if ($char === '\\'){
                                    $in_escape = true;
                                }
                            }
                        }
                    }
                    if ($new_line_level !== NULL){
                        $result .= "\n" . str_repeat("\t", $new_line_level);
                    }
                    $result .= $char . $post;
                }

                return $result;
            }

        static public function Crypto($string, $key, $iv, $decrypt)
            {
                if (!isset($string)){
                    return '';
                }
                $method = 'aes-256-cfb';
                if ($decrypt){
                    return openssl_decrypt(base64_decode($string), $method, $key, true, $iv);
                }
                else{
                    return base64_encode(openssl_encrypt($string, $method, $key, true, $iv));
                }
            }
            //this needs to be replaced with a way better logging API
            static public function AddLog($action, $user, $severity = 1, $invokinguser = 0)
            {
               DataAPI::Instance()->Insert("logs","user|action|severity|invokinguser","ssss", $user, $action,$severity,$invokinguser);
            }
            static public function GetLogs()
            {
                return DataAPI::Instance()->SelectAll("logs");
            }
        }
    }

