<?php
namespace Nexus\Helpers
{

    use mysqli;

    include "Singleton.php";

    class  DataAPI extends Singleton
    {
        public $con = NULL;

        /*connections*/
        public function Connect($user, $pass, $servername, $database)
        {
            $this->con = new mysqli($servername, $user, $pass, $database);
        }

        public function Disconnect()
        {
            $this->con->close();
        }

        public function GetLastError()
        {
            echo("Error description: " . $this->con->error);
        }
        /*Table Handlers*/
        //WIP

        /*data handlers*/
        /// table = ( what table to select from ) params = (with what to insert )  mask = ( format args for prepared SELECT statment)
        /// example Update("table_users", "address", "id|user", "iss", "12 baker street", 12, "anon" )  which evaluates to UPDATE table_users SET address = ? WHERE id = ? AND user = ?
        public function Update($table, $set, $where, $mask)
        {
            //check if we have a valid sql connection
            if (!isset($this->con) || $this->con->connect_error){
                print_r("mysqli connection is not valid");


                return;
            }

            //declare vars for later
            $ret = array();
            $param_ref = array();
            $count = func_num_args();
            $args = func_get_args();

            //check to see if we have a valid number of arguments
            if ($count > 4){
                //split parameter list

                //check if our type-mask is valid for the number of arguments
                if ($count - 4 == strlen($mask)){
                    //split set list
                    $setargs = explode('|', $set);

                    //get number of  set params
                    $setnum = sizeof($setargs);

                    //construct the begining of the statement
                    $sqlstr = "UPDATE " . $table . " SET ";

                    //construct parameters clause
                    for ($i = 0; $i < $setnum; $i++){
                        $sqlstr .= $setargs[$i];
                        if ($i < $setnum - 1){
                            $sqlstr .= " = ?, ";
                        }
                        else{
                            //end of command
                            $sqlstr .= " = ? WHERE ";
                        }
                    }

                    //split where list
                    $whereargs = explode('|', $where);

                    //get number of  where params
                    $wherenum = sizeof($whereargs);
                    //construct the VALUES clause of the sql statement
                    for ($i = 0; $i < $wherenum ; $i++){

                        $sqlstr .= $whereargs[$i];
                        if ($i < $wherenum - 1){
                            $sqlstr .= " = ? AND ";
                        }
                        else{
                            //end of command
                            $sqlstr .= " = ?";

                        }
                    }

                    if (strlen($mask) != ($wherenum + $setnum)){
                        print_r("Mask size does not match required number of parameters");
                    }

                    if (strlen($mask) != ($count - 4)){
                        print_r("Argument list does not match size of mask");
                    }

                    //create an array of references to pass to call_user_func_array

                    $param_ref[] = &$mask;
                    for ($i = 4; $i < sizeof($args); $i++){
                        $param_ref[] = &$args[$i];

                    }

                    //create prepared statement
                    $sqlstmt = $this->con->prepare($sqlstr);

                    //check to see if the statement was created successfully
                    if (!isset($sqlstmt)){
                        print_r("Failed to prepare statement");

                        return;
                    }

                    //call bind_param dynamically with a variable number of arguments
                    call_user_func_array(array($sqlstmt, 'bind_param'), $param_ref);

                    //execute prepared statment
                    $sqlstmt->execute();

                    //get return from statment and store it in an array
                   // $result = $sqlstmt->get_result();
                   // while ($row = $result->fetch_assoc()){
                   //     array_push($ret, $row);
                   // }

                    //close connection
                   // $sqlstmt->close();

                    //return result of select statement
                    return;
                }
                else{
                    //fail if number of arguments doesn't match the mask
                    print_r("Invalid mask for arg number");

                    return ;
                }
            }
            else{
                //fail of the number of arguments is invalid (should get a php warning anyway
                print_r("invalid argument number");

                return;
            }
        }

        /// table = ( what table to select from ) params = (with what to insert )  mask = ( format args for prepared SELECT statment)
        /// example Delete("table_users", "id|user|address", "iss", 12, "anon","12 baker street" )  which evaluates to INSERT INTO table_users(id,user,address) VALUES( ?, ?, ? )
        public function Delete($table, $params, $mask)
        {
            //check if we have a valid sql connection
            if (!isset($this->con) || $this->con->connect_error){
                print_r("mysqli connection is not valid");


                return;
            }

            //declare vars for later
            $ret = array();
            $param_ref = array();
            $count = func_num_args();
            $args = func_get_args();

            //check to see if we have a valid number of arguments
            if ($count >=3){
                //split parameter list

                //check if our type-mask is valid for the number of arguments
                if ($count - 3 == strlen($mask)){

                    //construct the begining of the statement
                    $sqlstr = "DELETE FROM " . $table . " WHERE ";

                    //split where list
                    $whereargs = explode('|', $params);

                    //get number of  where params
                    $wherenum = sizeof($whereargs);
                    //construct the VALUES clause of the sql statement
                    for ($i = 0; $i < $wherenum ; $i++){

                        $sqlstr .= $whereargs[$i];
                        if ($i < $wherenum - 1){
                            $sqlstr .= " = ? AND ";
                        }
                        else{
                            //end of command
                            $sqlstr .= " = ?";

                        }
                    }



                    if (strlen($mask) != ($count - 3)){
                        print_r("Argument list does not match size of mask");
                    }

                    //create an array of references to pass to call_user_func_array
                    $param_ref[] = &$mask;
                    for ($i = 3; $i < sizeof($args); $i++){
                        $param_ref[] = &$args[$i];

                    }

                    //create prepared statement
                    $sqlstmt = $this->con->prepare($sqlstr);

                    //check to see if the statement was created successfully
                    if (!isset($sqlstmt)){
                        print_r("Failed to prepare statement");

                        return;
                    }

                    //call bind_param dynamically with a variable number of arguments
                    call_user_func_array(array($sqlstmt, 'bind_param'), $param_ref);

                    //execute prepared statment
                    $sqlstmt->execute();


                    return;
                }
                else{
                    //fail if number of arguments doesn't match the mask
                    print_r("Invalid mask for arg number");

                    return ;
                }
            }
            else{
                //fail of the number of arguments is invalid (should get a php warning anyway
                print_r("invalid argument number");

                return;
            }
        }


        /// table = ( what table to select from ) params = (with what to insert )  mask = ( format args for prepared SELECT statment)
        /// example Insert("table_users", "id|user|address", "iss", 12, "anon","12 baker street" )  which evaluates to INSERT INTO table_users(id,user,address) VALUES( ?, ?, ? )
        public function Insert($table, $params, $mask)
        {
            //check if we have a valid sql connection
            if (!isset($this->con) || $this->con->connect_error){
                print_r("mysqli connection is not valid");

                return;
            }

            //declare vars for later
            $ret = array();
            $param_ref = array();
            $count = func_num_args();
            $args = func_get_args();

            //check to see if we have a valid number of arguments
            if ($count > 3){
                //split parameter list

                //check if our type-mask is valid for the number of arguments

                if ($count - 3 == strlen($mask)){
                    //split parameter list
                    $parameters = explode('|', $params);

                    //get number of  parameters
                    $paramnum = sizeof($parameters);

                    //construct the begining of the statement
                    $sqlstr = "INSERT INTO " . $table . "( ";

                    //construct parameters clause
                    for ($i = 0; $i < $paramnum; $i++){
                        $sqlstr .= $parameters[$i];
                        if ($i < $paramnum - 1){
                            $sqlstr .= ", ";
                        }
                        else{
                            //end of command
                            $sqlstr .= " ) ";
                        }
                    }

                    $sqlstr .= "VALUES( ";

                    //construct the VALUES clause of the sql statement
                    for ($i = 0; $i < strlen($mask) - 1; $i++){
                        $sqlstr .= "?, ";
                    }
                    $sqlstr .= "? )";

                    //create an array of references to pass to call_user_func_array
                    $param_ref[] = &$mask;
                    for ($i = 2; $i < sizeof($args); $i++){
                        $param_ref[$i - 2] = &$args[$i];
                    }

                    //create prepared statement
                    $sqlstmt = $this->con->prepare($sqlstr);

                    //check to see if the statement was created successfully
                    if (!isset($sqlstmt)){
                        print_r("Failed to prepare statement");

                        return;
                    }
                   //print_r($param_ref);
                    //call bind_param dynamically with a variable number of arguments
                    call_user_func_array(array($sqlstmt, 'bind_param'), $param_ref);

                    //execute prepared statment
                    $sqlstmt->execute();

                    //get return from statment and store it in an array
                    //$result = $sqlstmt->get_result();
                    //while ($row = $result->fetch_assoc()){
                    //    array_push($ret, $row);
                    //}

                    //close connection
                    $sqlstmt->close();

                    //return result of select statement
                    return;//$ret;
                }
                else{
                    //fail if number of arguments doesn't match the mask


                    print_r("Invalid mask for arg number");

                    return;
                }
            }
            else{
                //fail of the number of arguments is invalid (should get a php warning anyway
                print_r("invalid argument number");

                return;
            }
        }

        /// command = ( what to select) table = ( what table to select from ) params = (with what to select )  mask = ( format args for prepared SELECT statment)
        /// example Select("*", "table_users", "id|user|address", "iss", 12, "anon","12 baker street")  which evaluates to SELECT * FROM table_users WHERE id = ?, user = ?, address = ?
        public function Select($command, $table, $params, $mask)
        {
            //check if we have a valid sql connection
            if (!isset($this->con) || $this->con->connect_error){
                print_r("mysqli connection is not valid");

                return;
            }

            //declare vars for later
            $ret = array();
            $param_ref = array();
            $count = func_num_args();
            $args = func_get_args();

            //check to see if we have a valid number of arguments
            if ($count >= 4){
                //split parameter list
                $parameters = explode('|', $params);

                //get number of  parameters
                $paramnum = sizeof($parameters);

                //check if our type-mask is valid for the number of arguments

                if ($count - 4 == strlen($mask)){

                    //construct the begining of the statment
                    $sqlstr = "SELECT " . $command . " FROM " . $table;
                    $sqlstr .= " WHERE ";

                    //construct the WHERE clause of the sql statement
                    for ($i = 0; $i < $paramnum; $i++){
                        $sqlstr .= $parameters[$i];
                        if ($i < $paramnum - 1){
                            $sqlstr .= " = ? AND ";
                        }
                        else{
                            //end of command
                            $sqlstr .= " = ?";
                        }
                    }

                    //create an array of references to pass to call_user_func_array
                    $param_ref[] = &$mask;
                    for ($i = 4; $i < sizeof($args); $i++){
                        $param_ref[] = &$args[$i];
                    }

                    //create prepared statement
                    $sqlstmt = $this->con->prepare($sqlstr);

                    //check to see if the statement was created successfully
                    if (!isset($sqlstmt)){
                        print_r("Failed to prepare statement");

                        return;
                    }

                    //call bind_param dynamically with a variable number of arguments
                    call_user_func_array(array($sqlstmt, 'bind_param'), $param_ref);

                    //execute prepared statment
                    $sqlstmt->execute();

                    //get return from statment and store it in an array
                    $result = $sqlstmt->get_result();
                    while ($row = $result->fetch_assoc()){
                        array_push($ret, $row);
                    }

                    //close connection
                    $sqlstmt->close();

                    //return result of select statement
                    return $ret[0];
                }
                else{
                    //fail if number of arguments doesn't match the mask
                    print_r("Invalid mask for arg number");

                    return;
                }
            }
            else{
                //fail of the number of arguments is invalid (should get a php warning anyway
                print_r("invalid argument number");

                return;
            }
        }

        /// command = ( what to select) table = ( what table to select from ) params = (with what to select )  mask = ( format args for prepared SELECT statment)
        /// example Select("*", "table_users", "id|user|address", "iss", 12, "anon","12 baker street")  which evaluates to SELECT * FROM table_users WHERE id = ?, user = ?, address = ?
        public function SelectSpecial($command, $table, $params, $mask)
        {
            //check if we have a valid sql connection
            if (!isset($this->con) || $this->con->connect_error){
                print_r("mysqli connection is not valid");

                return;
            }

            //declare vars for later
            $ret = array();
            $param_ref = array();
            $count = func_num_args();
            $args = func_get_args();

            //check to see if we have a valid number of arguments
            if ($count >= 4){
                //split parameter list
                $parameters = explode('|', $params);

                //get number of  parameters
                $paramnum = sizeof($parameters);

                //check if our type-mask is valid for the number of arguments

                if ($count - 4 == strlen($mask)){

                    //construct the begining of the statment
                    $sqlstr = "SELECT " . $command . " FROM " . $table;
                    $sqlstr .= " WHERE ";

                    //construct the WHERE clause of the sql statement
                    for ($i = 0; $i < $paramnum; $i++){
                        $sqlstr .= $parameters[$i];
                        if ($i < $paramnum - 1){
                            $sqlstr .= " = ? AND ";
                        }
                        else{
                            //end of command
                            $sqlstr .= " = ?";
                        }
                    }

                    //create an array of references to pass to call_user_func_array
                    $param_ref[] = &$mask;
                    for ($i = 4; $i < sizeof($args); $i++){
                        $param_ref[] = &$args[$i];
                    }

                    //create prepared statement
                    $sqlstmt = $this->con->prepare($sqlstr);

                    //check to see if the statement was created successfully
                    if (!isset($sqlstmt)){
                        print_r("Failed to prepare statement");

                        return;
                    }

                    //call bind_param dynamically with a variable number of arguments
                    call_user_func_array(array($sqlstmt, 'bind_param'), $param_ref);

                    //execute prepared statment
                    $sqlstmt->execute();

                    //get return from statment and store it in an array
                    $result = $sqlstmt->get_result();
                    while ($row = $result->fetch_assoc()){
                        array_push($ret, $row);
                    }

                    //close connection
                    $sqlstmt->close();

                    //return result of select statement
                    return $ret;
                }
                else{
                    //fail if number of arguments doesn't match the mask
                    print_r("Invalid mask for arg number");

                    return;
                }
            }
            else{
                //fail of the number of arguments is invalid (should get a php warning anyway
                print_r("invalid argument number");

                return;
            }
        }
        /// command = ( what to select) table = ( what table to select from ) params = (with what to select )  mask = ( format args for prepared SELECT statment)
        /// example Select("*", "table_users", "id|user|address", "iss", 12, "anon","12 baker street")  which evaluates to SELECT * FROM table_users WHERE id = ?, user = ?, address = ?
        public function SelectAll($table)
        {
            //check if we have a valid sql connection
            if (!isset($this->con) || $this->con->connect_error){
                print_r("mysqli connection is not valid");

                return;
            }

            //declare vars for later
            $ret = array();

            //construct the begining of the statment
            $sqlstr = "SELECT * FROM " . $table;

            //create prepared statement
            $sqlstmt = $this->con->prepare($sqlstr);

            //check to see if the statement was created successfully
            if (!isset($sqlstmt)){
                print_r("Failed to prepare statement");

                return;
            }

            //execute prepared statment
            $sqlstmt->execute();

            //get return from statment and store it in an array
            $result = $sqlstmt->get_result();
            while ($row = $result->fetch_assoc()){
                array_push($ret, $row);
            }

            //close connection
            $sqlstmt->close();

            //return result of select statement
            return $ret;
        }
    }
}